    //
//  DeviceInfoViewController.m
//  uPnp2
//
//  Created by rk on 18/01/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import "DeviceInfoViewController.h"


@implementation DeviceInfoViewController

@synthesize device, deviceInfo;


//#pragma mark -
//#pragma mark UITextFieldDelegate methods
//
//-(BOOL)textFieldShouldBeginEditing:(UITextField *)textField {
//	// Stop the keyboard from appearing
//	return YES;
//}
//
//-(void) textFieldDidBeginEditing:(UITextField *)textField {
//	//[textField resignFirstResponder]; // pop down the keyboard
//}
//
//#pragma mark -

- (void) clearFields {
	urlLabel.text = nil;
	nameLabel.text = nil;
	manufacturerLabel.text = nil;
	modelLabel.text = nil;
	typeLabel.text = nil;
	udnLabel.text = nil;
}

- (void) setFields {
	urlLabel.text = [device._url absoluteString];
	[urlLabel sizeToFit];
	nameLabel.text = deviceInfo.friendlyName;
	manufacturerLabel.text = deviceInfo.manufacturer;
	modelLabel.text = deviceInfo.modelName;
	typeLabel.text = deviceInfo.deviceTypeSchema;
	udnLabel.text = deviceInfo.UDN;
}


- (void)setDevice:(UpnpDevice *)newDevice {
	device = newDevice;
	[self clearFields];
	[self setFields];
}

- (void) setDeviceInfo:(UpnpDeviceInfo *)newDeviceInfo {
	deviceInfo = newDeviceInfo;
	[self clearFields];
	[self setFields];
}

- (id) init {
	self = [super initWithNibName:@"DeviceInfoView" bundle:nil];
	return self;
}

 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
//    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
//    if (self) {
//        // Custom initialization.
//    }
	self = [self init];
    return self;
}



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	urlLabel.delegate = self;
	
	[[NSBundle mainBundle] loadNibNamed:@"EmptyKeyboard"
								owner:self
								options:nil];
	urlLabel.inputView = emptyKeyboard; // define a null keyboard for the urlLabel UITextField
}



- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Overriden to allow any orientation.
    return YES;
}


- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}


- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	device = nil;
	deviceInfo = nil;
	
    [super dealloc];
}


@end
