//
//  UpnpDevice.h
//  uPnp2
//
//  Created by rk on 3/01/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "UpnpDeviceInfo.h"

@protocol UpnpDeviceDelegate

@optional
- (void)upnpDeviceDisplayNameDidChangeValue:(NSNotification *)notification;
@end

extern NSString *UpnpDeviceDisplayNameDidChangeValueNotification;

typedef enum UpnpDeviceType {
	Undefined = 0,
	Renderer,
	Server
} UpnpDeviceType;

NSString * const SCHEMA_SERVER_STRING;
NSString * const SCHEMA_RENDERER_STRING;

@interface UpnpDevice : NSObject {
	IBOutlet id delegate;
	UpnpDeviceType _deviceType; // Type of device
	NSURL *_url; // URL of the device
	NSURLConnection *_connectionInProgress;
	NSMutableData *_readData;
	UpnpDeviceInfo *_deviceInfo;
}

@property (nonatomic, assign) IBOutlet id delegate;
@property (nonatomic, readonly) NSString *displayName;
@property (nonatomic) UpnpDeviceType _deviceType;
@property (nonatomic, retain) NSURL *_url;
@property (nonatomic, retain) NSMutableData *_readData;	
@property (nonatomic, retain) UpnpDeviceInfo *_deviceInfo;


- (id) init;
- (void) dealloc;

- (void) fetchDeviceInfo;
- (NSString *) _requestResponse;

@end
