//
//  UpnpDeviceInfo.m
//  uPnp2
//
//  Created by rk on 17/01/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import "UpnpDeviceInfo.h"


@implementation UpnpDeviceInfo

@synthesize deviceTypeSchema, friendlyName, manufacturer, modelName, UDN;

- (id) initWithXml:(NSData *)xml {
	if (!xml) self;
	
	NSXMLParser *parser = [[NSXMLParser alloc] initWithData:xml];
	[parser setDelegate:self];
	[parser parse];
	[parser release];
	return self;
}

#pragma mark -
#pragma mark NSXMLParserDelegate methods
- (void) parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName
				namespaceURI:(NSString *)namespaceURI
				qualifiedName:(NSString *)qualfilifiedName
				attributes:(NSDictionary *)attributeDict {
	// deviceTypeSchema, friendlyName, manufacturer, modelName, UDN;
	if ([elementName isEqual:@"deviceType"]) {
		deviceTypeSchema = [[NSMutableString alloc] init];
		currentParserField = deviceTypeSchema;
	}
	if ([elementName isEqual:@"friendlyName"]) {
		friendlyName = [[NSMutableString alloc] init];
		currentParserField = friendlyName;
	}
	if ([elementName isEqual:@"manufacturer"]) {
		manufacturer = [[NSMutableString alloc] init];
		currentParserField = manufacturer;
	}
	if ([elementName isEqual:@"modelName"]) {
		modelName = [[NSMutableString alloc] init];
		currentParserField = modelName;
	}
	if ([elementName isEqual:@"UDN"]) {
		UDN = [[NSMutableString alloc] init];
		currentParserField = UDN;
	}
	
}

- (void) parser:(NSXMLParser *)parser foundCharacters:(NSString *)string {
	[currentParserField appendString:string];
}

- (void) parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
				namespaceURI:(NSString *)namespaceURI
				qualifiedName:(NSString *)qualfilifiedName {
	currentParserField = nil;
}
	


#pragma mark -

- (void) dealloc {
	[deviceTypeSchema release];
	[friendlyName release];
	[manufacturer release];
	[modelName release];
	[UDN release];
	
	[super dealloc];
}

- (NSString *)description {
	return [NSString stringWithFormat:@"%@, %@", friendlyName, UDN];
}

@end
